package no.ntnu.idatt1002.demo.controller;

import javafx.collections.FXCollections;
import javafx.collections.ObservableList;
import javafx.event.ActionEvent;
import javafx.fxml.FXML;
import javafx.fxml.FXMLLoader;
import javafx.fxml.Initializable;
import javafx.scene.Node;
import javafx.scene.Parent;
import javafx.scene.Scene;
import javafx.scene.control.*;
import javafx.stage.Stage;
import no.ntnu.idatt1002.demo.data.recipes.*;

import java.io.IOException;
import java.net.URL;
import java.util.List;
import java.util.Optional;
import java.util.ResourceBundle;

public class SuggestRecipesController implements Initializable {

    IngredientsAtHand ingredientsAtHand;
    RecipeRegister recipeRegister;


    @FXML
    private Button addToFridgeBtn;

    @FXML
    private Button removeBtn;

    @FXML
    private Button goBackBtn;

    @FXML
    private ListView<String> fridgeList;

    private ObservableList<String> fridge;

    private ObservableList<Recipe> recipes;


    @FXML
    private void addIngredient(ActionEvent event) throws IOException {
        FXMLLoader loader = new FXMLLoader();
        System.out.println("Time to pop up the pop-up!");
        loader.setLocation(getClass().getResource("/view/AddIngredient.fxml"));
        DialogPane addIngredientPane = loader.load();

        AddIngredientController addIngredientController = loader.getController();

        Dialog<ButtonType> dialog = new Dialog<>();
        dialog.setDialogPane(addIngredientPane);
        dialog.setTitle("Add ingredient to fridge");

        Optional<ButtonType> clickedButton = dialog.showAndWait();

        if (clickedButton.get() == ButtonType.APPLY) {
        // Refresh ingredientsAtHand.
            ingredientsAtHand = FileHandler.readIngredientsAtHand("Fridge");
            //TODO: Duplicate
            fridge = FXCollections.observableArrayList(ingredientsAtHand.getIngredientsAtHand().stream().map(foodItem -> foodItem.label).toList());
            fridgeList.setItems(fridge);

            System.out.println("Clickecked OK!");
        }else if(clickedButton.get() == ButtonType.CANCEL) {
            System.out.println("Close the dialog");
        }
    }

    @FXML
    private void removeFromFridge(ActionEvent event) throws IOException {

        System.out.println("Remove the selected from fridge!");
        String toRemove = fridgeList.getSelectionModel().getSelectedItem();
        ingredientsAtHand.removeIngredient(FoodItem.valueOf(toRemove.replace(" ", "_").toUpperCase()));
        //TODO: Remove toUppercase solution above.
        //TODO: Consider factoring out to a update method.
        fridge = FXCollections.observableArrayList(ingredientsAtHand.getIngredientsAtHand().stream().map(foodItem -> foodItem.label).toList());
        fridgeList.setItems(fridge);
    }

/*    public void addToFridge(String ingredient) {
        System.out.println("Add to fridge!");
        String toRemove = fridgeList.getSelectionModel().getSelectedItem();
        ingredientsAtHand.addIngredient(FoodItem.valueOf(toRemove.toUpperCase()));
        //TODO: Remove toUppercase solution above.
        //TODO: Consider factoring out to a update method.
        fridge = FXCollections.observableArrayList(ingredientsAtHand.getIngredientsAtHand().stream().map(foodItem -> foodItem.label).toList());
        fridgeList.setItems(fridge);

    }*/


    @FXML
    private void goBack(ActionEvent event) throws IOException {
        FXMLLoader loader = new FXMLLoader();
        loader.setLocation(getClass().getResource("/view/MainMenuNew.fxml"));

        Parent root = loader.load();
        Stage stage = (Stage) ((Node) event.getSource()).getScene().getWindow();
        Scene scene = new Scene(root);
        stage.setScene(scene);
        stage.show();
    }

    private void setRecipeTiles(int number) {
        // Ingredeints at hand and recipesRegister
        Recipe[] recipes = recipeRegister.pickBestFits(4, ingredientsAtHand);


    }

    @Override
    public void initialize(URL url, ResourceBundle resourceBundle) {

        // If no ingredients at hand file exsists, add one and let it be empty. //TODO
         ingredientsAtHand = FileHandler.readIngredientsAtHand("Fridge");
         /*fridge = FXCollections.observableArrayList(ingredientsAtHand.getIngredientsAtHand());*/
        fridge = FXCollections.observableArrayList(ingredientsAtHand.getIngredientsAtHand().stream().map(foodItem -> foodItem.label).toList());
        List<String> fridgeLabels = fridge;
        /*List<String> fridgeLabels = fridge.stream().map(foodItem -> foodItem.label).toList();*/
         fridgeList.setItems(fridge);

         recipeRegister = FileHandler.readRecipeRegister("Recipes");
         recipes = FXCollections.observableArrayList(recipeRegister.getRecipes());

         // Get the number from FX-grid available?
         setRecipeTiles(4);

    }
}
